Subject: Re: [PATCH net-next v2 6/6] bonding: make Kconfig toggle to disable legacy interfaces

From: Stephen Hemminger <[email-masked]>
Date: Fri, 2 Oct 2020 15:42:22 -0700

On Fri, 2 Oct 2020 16:23:46 -0400
Jarod Wilson <[email-masked]> wrote:

> On Fri, Oct 2, 2020 at 3:13 PM Stephen Hemminger
> <[email-masked]> wrote:
> >
> > On Fri,  2 Oct 2020 13:40:01 -0400
> > Jarod Wilson <[email-masked]> wrote:
> >  
> > > By default, enable retaining all user-facing API that includes the use of
> > > master and slave, but add a Kconfig knob that allows those that wish to
> > > remove it entirely do so in one shot.
> > >
> > > Cc: Jay Vosburgh <[email-masked]>
> > > Cc: Veaceslav Falico <[email-masked]>
> > > Cc: Andy Gospodarek <[email-masked]>
> > > Cc: "David S. Miller" <[email-masked]>
> > > Cc: Jakub Kicinski <[email-masked]>
> > > Cc: Thomas Davis <[email-masked]>
> > > Cc: [email-masked]
> > > Signed-off-by: Jarod Wilson <[email-masked]>
> > > ---
> > >  drivers/net/Kconfig                   | 12 ++++++++++++
> > >  drivers/net/bonding/bond_main.c       |  4 ++--
> > >  drivers/net/bonding/bond_options.c    |  4 ++--
> > >  drivers/net/bonding/bond_procfs.c     |  8 ++++++++
> > >  drivers/net/bonding/bond_sysfs.c      | 14 ++++++++++----
> > >  drivers/net/bonding/bond_sysfs_port.c |  6 ++++--
> > >  6 files changed, 38 insertions(+), 10 deletions(-)
> > >  
> >
> > This is problematic. You are printing both old and new values.
> > Also every distribution will have to enable it.
> >
> > This looks like too much of change to users.  
> 
> I'd had a bit of feedback that people would rather see both, and be
> able to toggle off the old ones, rather than only having one or the
> other, depending on the toggle, so I thought I'd give this a try. I
> kind of liked the one or the other route, but I see the problems with
> that too.
> 
> For simplicity, I'm kind of liking the idea of just not updating the
> proc and sysfs interfaces, have a toggle entirely disable them, and
> work on enhancing userspace to only use netlink, but ... it's going to
> be a while before any such work makes its way to any already shipping
> distros. I don't have a satisfying answer here.
> 

I like the idea of having bonding proc and sysf apis optional.